diff --git a/web/pgadmin/preferences/tests/test_preferences_update.py b/web/pgadmin/preferences/tests/test_preferences_update.py
new file mode 100644
index 00000000..6b9eccc0
--- /dev/null
+++ b/web/pgadmin/preferences/tests/test_preferences_update.py
@@ -0,0 +1,60 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2022, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import os
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from regression.test_setup import config_data
+from regression import parent_node_dict
+import json
+import config
+
+test_user_details = None
+if config.SERVER_MODE:
+    test_user_details = config_data['pgAdmin4_test_non_admin_credentials']
+
+CURRENT_PATH = os.path.dirname(os.path.realpath(__file__))
+with open(CURRENT_PATH + "/preferences_test_data.json") as data_file:
+    test_cases = json.load(data_file)
+
+
+class GetPreferencesTest(BaseTestGenerator):
+    """
+    This class will fetch all Preferences
+    """
+
+    scenarios = utils.generate_scenarios('update_preferences', test_cases)
+
+    def setUp(self):
+        response = self.tester.get(self.url,
+                                   content_type='html/json')
+        self.assertTrue(response.status_code, 200)
+        parent_node_dict['preferences'] = response.data
+
+    def runTest(self):
+        self.update_preferences()
+
+    def update_preferences(self):
+        if 'preferences' in parent_node_dict:
+            data = \
+                json.loads(parent_node_dict['preferences'])[0]['children'][0][
+                    'preferences'][0]
+            updated_data = [{
+                'id': data['id'],
+                'category_id': data['cid'],
+                'mid': data['mid'],
+                'name': data['name'],
+                'value': not data['value']
+            }]
+            response = self.tester.put(self.url,
+                                       data=json.dumps(updated_data),
+                                       content_type='html/json')
+            self.assertTrue(response.status_code, 200)
+        else:
+            self.fail('Preferences not found')
diff --git a/web/pgadmin/static/js/SchemaView/MappedControl.jsx b/web/pgadmin/static/js/SchemaView/MappedControl.jsx
index a361b828..8018799a 100644
--- a/web/pgadmin/static/js/SchemaView/MappedControl.jsx
+++ b/web/pgadmin/static/js/SchemaView/MappedControl.jsx
@@ -9,18 +9,19 @@
 
 import React, { useCallback } from 'react';
 import _ from 'lodash';
-
-import { FormInputText, FormInputSelect, FormInputSwitch, FormInputCheckbox, FormInputColor,
-  FormInputFileSelect, FormInputToggle, InputSwitch, FormInputSQL, FormNote, FormInputDateTimePicker, PlainString, InputSQL,
-  InputSelect, InputText, InputCheckbox, InputDateTimePicker } from '../components/FormComponents';
+import {
+  FormInputText, FormInputSelect, FormInputSwitch, FormInputCheckbox, FormInputColor,
+  FormInputFileSelect, FormInputToggle, InputSwitch, FormInputSQL, InputSQL, FormNote, FormInputDateTimePicker, PlainString,
+  InputSelect, InputText, InputCheckbox, InputDateTimePicker, InputFileSelect, FormInputKeyboardShortcut, FormInputQueryThreshold
+} from '../components/FormComponents';
 import Privilege from '../components/Privilege';
 import { evalFunc } from 'sources/utils';
 import PropTypes from 'prop-types';
 import CustomPropTypes from '../custom_prop_types';
-import { SelectRefresh} from '../components/SelectRefresh';
+import { SelectRefresh } from '../components/SelectRefresh';
 
 /* Control mapping for form view */
-function MappedFormControlBase({type, value, id, onChange, className, visible, inputRef, noLabel, ...props}) {
+function MappedFormControlBase({ type, value, id, onChange, className, visible, inputRef, noLabel, ...props }) {
   const name = id;
   const onTextChange = useCallback((e) => {
     let val = e;
@@ -34,36 +35,36 @@ function MappedFormControlBase({type, value, id, onChange, className, visible, i
     onChange && onChange(changedValue);
   }, []);
 
-  if(!visible) {
+  if (!visible) {
     return <></>;
   }
 
   /* The mapping uses Form* components as it comes with labels */
   switch (type) {
   case 'int':
-    return <FormInputText name={name} value={value} onChange={onTextChange} className={className} inputRef={inputRef} {...props} type='int'/>;
+    return <FormInputText name={name} value={value} onChange={onTextChange} className={className} inputRef={inputRef} {...props} type='int' />;
   case 'numeric':
-    return <FormInputText name={name} value={value} onChange={onTextChange} className={className} inputRef={inputRef} {...props} type='numeric'/>;
+    return <FormInputText name={name} value={value} onChange={onTextChange} className={className} inputRef={inputRef} {...props} type='numeric' />;
   case 'tel':
-    return <FormInputText name={name} value={value} onChange={onTextChange} className={className} inputRef={inputRef} {...props} type='tel'/>;
+    return <FormInputText name={name} value={value} onChange={onTextChange} className={className} inputRef={inputRef} {...props} type='tel' />;
   case 'text':
-    return <FormInputText name={name} value={value} onChange={onTextChange} className={className} inputRef={inputRef} {...props}/>;
+    return <FormInputText name={name} value={value} onChange={onTextChange} className={className} inputRef={inputRef} {...props} />;
   case 'multiline':
     return <FormInputText name={name} value={value} onChange={onTextChange} className={className}
-      inputRef={inputRef} controlProps={{multiline: true}} {...props}/>;
+      inputRef={inputRef} controlProps={{ multiline: true }} {...props} />;
   case 'password':
-    return <FormInputText name={name} value={value} onChange={onTextChange} className={className} type='password' inputRef={inputRef} {...props}/>;
+    return <FormInputText name={name} value={value} onChange={onTextChange} className={className} type='password' inputRef={inputRef} {...props} />;
   case 'select':
     return <FormInputSelect name={name} value={value} onChange={onTextChange} className={className} inputRef={inputRef} {...props} />;
   case 'select-refresh':
     return <SelectRefresh name={name} value={value} onChange={onTextChange} className={className} {...props} />;
   case 'switch':
     return <FormInputSwitch name={name} value={value}
-      onChange={(e)=>onTextChange(e.target.checked, e.target.name)} className={className}
+      onChange={(e) => onTextChange(e.target.checked, e.target.name)} className={className}
       {...props} />;
   case 'checkbox':
     return <FormInputCheckbox name={name} value={value}
-      onChange={(e)=>onTextChange(e.target.checked, e.target.name)} className={className}
+      onChange={(e) => onTextChange(e.target.checked, e.target.name)} className={className}
       {...props} />;
   case 'toggle':
     return <FormInputToggle name={name} value={value}
@@ -76,9 +77,13 @@ function MappedFormControlBase({type, value, id, onChange, className, visible, i
   case 'sql':
     return <FormInputSQL name={name} value={value} onChange={onSqlChange} className={className} noLabel={noLabel} {...props} />;
   case 'note':
-    return <FormNote className={className} {...props}/>;
+    return <FormNote className={className} {...props} />;
   case 'datetimepicker':
     return <FormInputDateTimePicker name={name} value={value} onChange={onTextChange} className={className} {...props} />;
+  case 'keyboardShortcut':
+    return <FormInputKeyboardShortcut name={name} value={value} onChange={onTextChange} {...props}/>;
+  case 'threshold':
+    return <FormInputQueryThreshold name={name} value={value} onChange={onTextChange} {...props}/>;
   default:
     return <PlainString value={value} {...props} />;
   }
@@ -100,11 +105,11 @@ MappedFormControlBase.propTypes = {
 };
 
 /* Control mapping for grid cell view */
-function MappedCellControlBase({cell, value, id, optionsLoaded, onCellChange, visible, reRenderRow,...props}) {
+function MappedCellControlBase({ cell, value, id, optionsLoaded, onCellChange, visible, reRenderRow, ...props }) {
   const name = id;
   const onTextChange = useCallback((e) => {
     let val = e;
-    if(e && e.target) {
+    if (e && e.target) {
       val = e.target.value;
     }
 
@@ -118,13 +123,13 @@ function MappedCellControlBase({cell, value, id, optionsLoaded, onCellChange, vi
   /* Some grid cells are based on options selected in other cells.
    * lets trigger a re-render for the row if optionsLoaded
    */
-  const optionsLoadedRerender = useCallback((res)=>{
+  const optionsLoadedRerender = useCallback((res) => {
     /* optionsLoaded is called when select options are fetched */
     optionsLoaded && optionsLoaded(res);
     reRenderRow && reRenderRow();
   }, []);
 
-  if(!visible) {
+  if (!visible) {
     return <></>;
   }
 
@@ -142,7 +147,7 @@ function MappedCellControlBase({cell, value, id, optionsLoaded, onCellChange, vi
     return <InputSelect name={name} value={value} onChange={onTextChange} optionsLoaded={optionsLoadedRerender} {...props}/>;
   case 'switch':
     return <InputSwitch name={name} value={value}
-      onChange={(e)=>onTextChange(e.target.checked, e.target.name)} {...props} />;
+      onChange={(e)=>onTextChange(e.target.checked, e.target.name)} disabled={props.disabled} {...props} />;
   case 'checkbox':
     return <InputCheckbox name={name} value={value}
       onChange={(e)=>onTextChange(e.target.checked, e.target.name)} {...props} />;
@@ -152,6 +157,10 @@ function MappedCellControlBase({cell, value, id, optionsLoaded, onCellChange, vi
     return <InputDateTimePicker name={name} value={value} onChange={onTextChange} {...props}/>;
   case 'sql':
     return <InputSQL name={name} value={value} onChange={onSqlChange} {...props} />;
+  case 'file':
+    return <InputFileSelect name={name} value={value} onChange={onTextChange} inputRef={props.inputRef} {...props} />;
+  case 'keyCode':
+    return <InputText name={name} value={value} onChange={onTextChange} {...props} type='text' maxlength={1} />;
   default:
     return <PlainString value={value} {...props} />;
   }
@@ -167,14 +176,16 @@ MappedCellControlBase.propTypes = {
   reRenderRow: PropTypes.func,
   optionsLoaded: PropTypes.func,
   onCellChange: PropTypes.func,
-  visible: PropTypes.bool
+  visible: PropTypes.bool,
+  disabled: PropTypes.bool,
+  inputRef: CustomPropTypes.ref,
 };
 
 const ALLOWED_PROPS_FIELD_COMMON = [
   'mode', 'value', 'readonly', 'disabled', 'hasError', 'id',
   'label', 'options', 'optionsLoaded', 'controlProps', 'schema', 'inputRef',
   'visible', 'autoFocus', 'helpMessage', 'className', 'optionsReloadBasis',
-  'orientation'
+  'orientation', 'isvalidate', 'fields'
 ];
 
 const ALLOWED_PROPS_FIELD_FORM = [
@@ -182,14 +193,14 @@ const ALLOWED_PROPS_FIELD_FORM = [
 ];
 
 const ALLOWED_PROPS_FIELD_CELL = [
-  'cell', 'onCellChange', 'row', 'reRenderRow',
+  'cell', 'onCellChange', 'row', 'reRenderRow', 'validate', 'disabled', 'readonly'
 ];
 
 
-export const MappedFormControl = (props)=>{
-  let newProps = {...props};
+export const MappedFormControl = (props) => {
+  let newProps = { ...props };
   let typeProps = evalFunc(null, newProps.type, newProps.state);
-  if(typeof(typeProps) === 'object') {
+  if (typeof (typeProps) === 'object') {
     newProps = {
       ...newProps,
       ...typeProps,
@@ -199,13 +210,13 @@ export const MappedFormControl = (props)=>{
   }
 
   /* Filter out garbage props if any using ALLOWED_PROPS_FIELD */
-  return <MappedFormControlBase {..._.pick(newProps, _.union(ALLOWED_PROPS_FIELD_COMMON, ALLOWED_PROPS_FIELD_FORM))}/>;
+  return <MappedFormControlBase {..._.pick(newProps, _.union(ALLOWED_PROPS_FIELD_COMMON, ALLOWED_PROPS_FIELD_FORM))} />;
 };
 
-export const MappedCellControl = (props)=>{
-  let newProps = {...props};
+export const MappedCellControl = (props) => {
+  let newProps = { ...props };
   let cellProps = evalFunc(null, newProps.cell, newProps.row);
-  if(typeof(cellProps) === 'object') {
+  if (typeof (cellProps) === 'object') {
     newProps = {
       ...newProps,
       ...cellProps,
@@ -215,5 +226,5 @@ export const MappedCellControl = (props)=>{
   }
 
   /* Filter out garbage props if any using ALLOWED_PROPS_FIELD */
-  return <MappedCellControlBase {..._.pick(newProps, _.union(ALLOWED_PROPS_FIELD_COMMON, ALLOWED_PROPS_FIELD_CELL))}/>;
+  return <MappedCellControlBase {..._.pick(newProps, _.union(ALLOWED_PROPS_FIELD_COMMON, ALLOWED_PROPS_FIELD_CELL))} />;
 };
diff --git a/web/pgadmin/static/js/SchemaView/index.jsx b/web/pgadmin/static/js/SchemaView/index.jsx
index 8b20d5f5..3febb103 100644
--- a/web/pgadmin/static/js/SchemaView/index.jsx
+++ b/web/pgadmin/static/js/SchemaView/index.jsx
@@ -108,7 +108,7 @@ function getChangedData(topSchema, viewHelperProps, sessData, stringify=false, i
 
     /* The comparator and setter */
     const attrChanged = (id, change, force=false)=>{
-      if(isValueEqual(_.get(origVal, id), _.get(sessVal, id)) && !force) {
+      if(isValueEqual(_.get(origVal, id), _.get(sessVal, id)) && !force && (_.isObject(_.get(origVal, id)) && _.isEqual(_.get(origVal, id), _.get(sessData, id)))) {
         return;
       } else {
         change = change || _.get(sessVal, id);
